## Fresenius M3 Integration Project ##

Fresenius would like their Order Management System, IntelliOrder (IO) hosted by AmerisourceBergen (AB), to provide Advance Ship Notices (ASNs) to the Bar Code Direct (BCD) system.

Once in the BCD system, the ASNs will be pushed to Devices for Receiving workflow.

All Receipts will flow from the devices to the BCD database.  From there, BCD will be responsible for pushing datat to the Fresensius SAP system.

### What is this repository for? ###

This repository is to setup and handle

* the communication between IO and BCD
* the communication between BCD and SAP

### How do I get set up? ###

* Clone this repository.
* In the folder where this is cloned, open a command prompt. Type:
> npm install
* Launch IntelliJ Ultimate (license required) with NodeJS plugin
* Create a "New Project with Existing Sources..."

### Config File Explained ###

Location: /components/config

Name:  server.`[env]`.js

    module.exports = {
        "auth": {
            "secret": "The secret salt used by the JWT generator",
            "token_ttl_hours": Number of hours for the token to be live
        },
        "mqs": "rabbit|sqs|null/garbage"
    };

NOTES:

* The auth.secret parameter is **auto-generated** (using `uuid.v4`) on every launch of the web server.  Consider it a rotating key.

|"mqs" Setting  |Writes To  |
| --------|---------|
|"rabbit"|RabbitMQ|
|"sqs"|Amazon SQS|
|null (or anything else)|A file (`/db/file_q/test_msgs.txt`) instead of a Q*|

\* For logging only.  No records are inserted into the database via the [ASN project](https://bitbucket.org/elx_pete/fresenius-m3-asn).

### Who do I talk to? ###

* John Amaral