var rp = require("request-promise");

function ASN(config) {
    this.config = config;
}

/**
 * Retrieves all OPEN ASNs so the Receipts will link to a valid parent
 * @returns {Promise} API GET promise that will get the data
 */
ASN.prototype.getAsns = function() {
    var url = this.config.perf.asn;
    var options = {
        uri: url + "/api/v1/asn/open",
        method: 'GET',
        headers: {
            'User-Agent': 'fmc (node/' + process.version + ')',
            'Content-Type': 'application/json'
        },
        json: true,
        resolveWithFullResponse: true
    };
    return rp(options).promise();

};

module.exports = ASN;