/**
 * Created by John on 7/6/2017.
 */

var moment = require("moment");
var fs = require("fs");
var path = require("path");
var json2csv = require('json2csv');

function SAP(config) {
    this.config = config;
}

SAP.prototype.send = function(data) {
    //TODO: implement
    return new Promise(function(resolve, reject){
        console.log(JSON.stringify(data));
        resolve({ status: 200, body: {} });
    })
};

SAP.prototype.toFile = function(data) {
    var sub = (this.config.fileOutput && this.config.fileOutput.SAP) ? this.config.fileOutput.SAP : "";
    return new Promise(function(resolve, reject){
        //convert the data to TSV
        var fields = ['asn.asnId', 'asn.asnDate', 'poNumber', 'asn.vendorId', 'asn.vendorName', 'asn.clinicId', 'asn.shipToAccount', 'asn.shipToName', 'asn.shipFromId', 'asn.shipVia', 'asn.vendorItemId', 'asn.ndc', 'asn.shipQty', 'asn.unitPrice', 'asn.uom', 'asn.description', 'asn.lot', 'asn.expiration', 'asn.invoiceNumber', 'asn.lineNumber', 'asn.trackingId', 'clinicId', 'receivedDate', 'receivedQty', 'lot', 'expiration'];
        json2csv({data: data, fields: fields, del: '\t', hasCSVColumnTitle:false }, function (err, csv) {
            if (err) {
                reject(err);
            } else {
                //WRITE TO FILE
                var m = new moment();
                var filename = "IO_BCD_GR_" + m.format("YYYYMMDD_HHmmss") + ".txt";

                try {
                    if (!sub || sub === "") {
                        var root = path.join(__dirname, "..", "..", "db");
                        if (!fs.existsSync(root)) fs.mkdirSync(root);
                        sub = path.join(root, "file_q");
                        if (!fs.existsSync(sub)) fs.mkdirSync(sub);
                    }
                    var fullPath = path.join(sub, filename);
                    fs.appendFile(fullPath, csv, function (err) {
                        if (err) {
                            reject(err);
                        } else {
                            resolve({status: 200, body: {}});
                        }
                    });
                } catch (fsErr) {
                    reject(fsErr);
                }
            }
        });
    });

};

module.exports = SAP;